org.apache.tomcat.util.net

## Class SSLUtilBase

- java.lang.Object
- - org.apache.tomcat.util.net.SSLUtilBase

- All Implemented Interfaces:
    SSLUtil
  Direct Known Subclasses:
    JSSEUtil, OpenSSLUtil

      public abstract class SSLUtilBase
      extends Object
      implements SSLUtil

  Common base class for `SSLUtil` implementations.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.apache.tomcat.util.net.SSLUtil

      `SSLUtil.ProtocolInfo`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected SSLHostConfigCertificate` | `certificate`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `SSLUtilBase(SSLHostConfigCertificate certificate)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `String[]` | `getEnabledCiphers()` The set of enabled ciphers is the intersection of the implemented ciphers and the configured ciphers.
    `String[]` | `getEnabledProtocols()` The set of enabled protocols is the intersection of the implemented protocols and the configured protocols.
    `protected abstract Set<String>` | `getImplementedCiphers()`
    `protected abstract Set<String>` | `getImplementedProtocols()`
    `protected abstract Log` | `getLog()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.tomcat.util.net.SSLUtil

      `configureSessionContext, createSSLContext, getKeyManagers, getTrustManagers`

- - ### Field Detail

    - #### certificate

          protected final SSLHostConfigCertificate certificate

  - ### Constructor Detail

    - #### SSLUtilBase

          protected SSLUtilBase(SSLHostConfigCertificate certificate)

  - ### Method Detail

    - #### getEnabledProtocols

          public String[] getEnabledProtocols()

      Description copied from interface: `SSLUtil`
      The set of enabled protocols is the intersection of the implemented protocols and the configured protocols. If no protocols are explicitly configured, then all of the implemented protocols will be included in the returned array.
      Specified by:
        `getEnabledProtocols` in interface `SSLUtil`
      Returns:
        The protocols currently enabled and available for clients to select from for the associated connection

    - #### getEnabledCiphers

          public String[] getEnabledCiphers()

      Description copied from interface: `SSLUtil`
      The set of enabled ciphers is the intersection of the implemented ciphers and the configured ciphers. If no ciphers are explicitly configured, then the default ciphers will be included in the returned array.

      The ciphers used during the TLS handshake may be further restricted by the `SSLUtil.getEnabledProtocols()` and the certificates.

      Specified by:
        `getEnabledCiphers` in interface `SSLUtil`
      Returns:
        The ciphers currently enabled and available for clients to select from for the associated connection

    - #### getImplementedProtocols

          protected abstract Set<String> getImplementedProtocols()

    - #### getImplementedCiphers

          protected abstract Set<String> getImplementedCiphers()

    - #### getLog

          protected abstract Log getLog()

Copyright © 2000-2017 Apache Software Foundation. All Rights Reserved.